package gui;

import java.awt.Color;
import java.awt.Font;
import java.util.Observable;
import java.util.Observer;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;
import javax.swing.SwingConstants;
import javax.swing.JLabel;

import model.Status;

public class StatusLabel extends JLabel implements Observer {

    private final float FONT_SIZE = 16;

    public StatusLabel(Status status) {
        super("                            ", SwingConstants.LEFT);
        setBackground(Color.WHITE);
        setOpaque(true);
        setFont(getFont().deriveFont( FONT_SIZE ));

        status.addObserver(this);
        setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.LIGHT_GRAY, Color.DARK_GRAY));
    }

    public void update(Observable observable, Object object) {
        setText((String)object);
    }
}

