package gui.menu;

import model.SchedulingModel;
import model.Status;
import gui.CurrentSlot;
import gui.ScheduLearn;
import tasks.Taskset;
import javax.swing.JMenu;
import javax.swing.JMenuBar;

public class ScheduLearnMenuBar extends JMenuBar {
    public ScheduLearnMenuBar(ScheduLearn gui, 
            SchedulingModel scheduleMdl, 
            Taskset taskset, 
            Status status) {

        JMenu file = new JMenu("File");
        JMenu edit = new JMenu("Edit");
        JMenu strategy = new JMenu("Strategy");
        JMenu help = new HelpMenu();

        file.add(new SaveMenuItem(gui, taskset, status));
        file.add(new LoadMenuItem(gui, taskset, status));
        edit.add(new MatchMenuItem(scheduleMdl, status));
        edit.add(new ClearCellsMenuItem(scheduleMdl));
        edit.add(new ClearTasksetMenuItem(taskset));
        edit.add(new ClearAllMenuItem(scheduleMdl));
        strategy.add(new NoneStrategyMenuItem(scheduleMdl));
        strategy.add(new FPStrategyMenuItem(scheduleMdl));
        strategy.add(new EDFStrategyMenuItem(scheduleMdl));
        strategy.add(new RMSStrategyMenuItem(scheduleMdl));

        add(file);
        add(edit);
        add(strategy);
        add(help);
    }
}
