package gui.menu;

import strategy.SchedulingStrategy;
import model.SchedulingModel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;

public abstract class StrategyMenuItem extends JMenuItem implements ActionListener {
    private SchedulingStrategy strategy;
    private SchedulingModel scheduleMdl;

    public StrategyMenuItem(SchedulingModel scheduleMdl, SchedulingStrategy strategy, String title) {
        super(title);
        this.scheduleMdl = scheduleMdl;
        this.strategy = strategy;
        addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
        scheduleMdl.setStrategy(strategy);
    }
}
