package gui.menu.help;

import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;

public class OptionList extends JList {

    private EventListener listener;

    public OptionList(String[] items) {
        super(items);

        setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        setLayoutOrientation(JList.VERTICAL);
        setVisibleRowCount(-1);
        setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));

        addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if (!e.getValueIsAdjusting()) { 
                    listener.update(getSelectedValue().toString());
                }
            }
        });
    }

    public void addListener(EventListener listener) {
        this.listener = listener;
    }
}
