package gui.menu.help;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.Map;
import java.util.HashMap;

public abstract class TabPanel extends JPanel implements EventListener {

    private final String[] listOptions;
    private OptionList list;
    private Map<String, JTextArea> helpTexts = new HashMap<>();

    public TabPanel(String[] listOptions, String[] fieldTexts) {
        super(new BorderLayout());
        this.listOptions = listOptions;

        list = new OptionList(listOptions);
        list.addListener(this);
        list.setPreferredSize(new Dimension(120, 400));

        for (int i = 0; i < listOptions.length; i++) {
            JTextArea htf = new HelpTextArea(fieldTexts[i]);
            helpTexts.put(listOptions[i], htf);
        }

        add(BorderLayout.WEST, list);
        add(BorderLayout.CENTER, new HelpTextArea(""));
    }

    public void update(String tab) {
        removeAll();
        add(BorderLayout.WEST, list);

        if (helpTexts.containsKey(tab)) {
            add(BorderLayout.CENTER, helpTexts.get(tab));
        }

        revalidate();
        repaint();
    }
}
