package gui.schedulegui;

import java.awt.event.MouseListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import model.SchedulingModel;
import gui.CurrentSlot;

public class ScheduleGrid extends Grid {
    private CurrentSlot currentSlot;
    private SlotLabel currentSlotLabel;

    public ScheduleGrid(int rows, int cols, SchedulingModel scheduleMdl, CurrentSlot currentSlot) {
        super(rows, cols, scheduleMdl, "Schedule");
        this.currentSlot = currentSlot; 
    }

    /*
     * Adds MouseListener to each label
     */
    protected void addListener(SchedulingModel scheduleMdl, SlotLabel label) {
        
        // Add mouseListener to label.
        label.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                // toggle color of current slot label
                currentSlotLabel = label;
                currentSlot.setCurrentSlot(getAdress(currentSlotLabel));
                boolean activated = currentSlotLabel.toggle(currentSlot.getCurrentTask());

                // If active: Add to activeLabels; else: remove
                if (activated) {
                    putActiveLabel(currentSlot.toString(), currentSlotLabel);
                } else {
                    removeActiveLabel(currentSlot.toString());
                }

                // Activate cell in scheduleMdl
                scheduleMdl.activateCell(currentSlot.toString(), currentSlot.getCurrentTask(), activated);
            }
        });
    }

    /*
     * If scheduleMdl is cleared: clear active cells.
     */
    protected void updateAction(SchedulingModel scheduleMdl) {
        if (scheduleMdl.isCleared()) {
            clearActive();
        }
    }
}
