package gui.schedulegui;

import javax.swing.JPanel;
import static java.awt.BorderLayout.CENTER;
import static java.awt.BorderLayout.WEST;
import static java.awt.BorderLayout.SOUTH;

import gui.BorderPanel;
import gui.CurrentSlot;
import model.SchedulingModel;

public class SchedulePanel extends BorderPanel {
    // GridPanel, RowLabels, SlotLabels
    public SchedulePanel(SchedulingModel scheduleMdl, CurrentSlot currentSlot, int rows, int cols) {
        JPanel rowLabelsUp   = new RowLabels(rows);
        JPanel rowLabelsLow  = new RowLabels(rows);

        JPanel scheduleGrid  = new ScheduleGrid(rows, cols, scheduleMdl, currentSlot);

        JPanel solutionGrid  = new SolutionGrid(rows, cols, scheduleMdl);
        JPanel solutionPanel = new SolutionPanel(solutionGrid, rowLabelsLow);

        add(WEST, rowLabelsUp);
        add(CENTER, scheduleGrid);
        add(SOUTH, solutionPanel);
    }
}
