package gui.schedulegui;

import java.awt.Color;
import model.ColorEnum;

public class SlotLabel extends ColoredLabel {
    public SlotLabel() {
        super("        ", Color.WHITE, RIGHT);
    }

    /*
     * Toggles background color of this slot label based on white and color
     */
    public boolean toggle(int task) {
        if (this.getBackground() != Color.WHITE) {
            this.setBackground(Color.WHITE);
            return false;
        } else {
            this.setBackground(ColorEnum.valueOf(task).color());
            return true;
        }
    }

    /*
     * Toggles background color of this slot label based on white and light grey
     */
    public boolean toggle() {
        if (this.getBackground() != Color.WHITE) {
            this.setBackground(Color.WHITE);
            return false;
        } else {
            this.setBackground(Color.LIGHT_GRAY);
            return true;
        }
    }
}
