package gui.schedulegui;

import java.awt.GridLayout;

import model.SchedulingModel;

public class SolutionGrid extends Grid {

    public SolutionGrid(int rows, int cols, SchedulingModel scheduleMdl) {
        super(rows, cols, scheduleMdl, "Solution");
        updateAction(scheduleMdl);
    }

    /*
     * No listener needed
     */
    protected void addListener(SchedulingModel scheduleModel, SlotLabel s) {}
    
    /*
     * When scheduleMdl is updated, we update solution.
     */
    protected void updateAction(SchedulingModel scheduleMdl) {
        //Clears the solution panel before new solution
        clearActive(); 

        if (scheduleMdl.solutionIsValid()) {
            //Add the solution
            int[] solution = scheduleMdl.getSolution();
            for (int col = 0; col < ((GridLayout)getLayout()).getColumns() && col < solution.length; col++) {
                if (solution[col] != 0) {
                    String id = parse(solution[col], col + 1);
                    labelMap.get(id).toggle(solution[col]);
                    activeLabels.put(id, labelMap.get(id));
                }
            }
            
            //Mark the hyperperiod
            for (int row = 1; 
                    row < ((GridLayout)getLayout()).getRows() && 
                    solution.length + 1 <= ((GridLayout)getLayout()).getColumns();
                    row++) {
                String id = parse(row, solution.length + 1);
                labelMap.get(id).toggle(); 
                activeLabels.put(id, labelMap.get(id));
            }
        } 
    }
}
