package gui.schedulegui;

import java.awt.Color;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import static java.awt.BorderLayout.NORTH;
import static java.awt.BorderLayout.CENTER;
import static java.awt.BorderLayout.WEST;

import model.SchedulingModel;
import model.Schedule;
import gui.BorderPanel;

public class SolutionPanel extends BorderPanel {

    private JPanel solutionGrid, rowLabels;
    private JButton button = new ShowSolutionButton(this);
    private JTextField field;
    private boolean visible = false;

    public SolutionPanel(JPanel solutionGrid, JPanel rowLabels) {
        this.solutionGrid = solutionGrid;
        this.rowLabels = rowLabels;

        field = new JTextField("Solution Hidden"); 
        field.setHorizontalAlignment(JTextField.CENTER);
        field.setFont(field.getFont().deriveFont(Font.BOLD));
        field.setBackground(Color.LIGHT_GRAY);

        add(NORTH, button);
        add(CENTER, field);

        setPreferredSize(new Dimension(400, 160));
    }

    /*
     * Toggle solution panel so it is visible or invisible
     */
    public void toggle() {

        if (visible) {
            hideSolution();
            visible = false;
        } else {
            viewSolution();
            visible = true;
        }
    }

    private void hideSolution() {
        BorderLayout layout = (BorderLayout) getLayout();
        remove(layout.getLayoutComponent(CENTER));
        remove(layout.getLayoutComponent(WEST));

        add(CENTER, field);
        revalidate();
        repaint();
    }

    private void viewSolution() {
        BorderLayout layout = (BorderLayout) getLayout();
        remove(layout.getLayoutComponent(CENTER));

        add(WEST, rowLabels);
        add(CENTER, solutionGrid);
        revalidate();
        repaint();
    }
}
