package model;

import java.awt.Color;

public enum ColorEnum {
    YELLOW(1), 
    GREEN(2), 
    RED(3), 
    BLUE(4), 
    MAGENTA(5),
    CYAN(6), 
    ORANGE(7);

    private int task;

    private ColorEnum(int task) { this.task = task; }

    public static ColorEnum valueOf(int task) {
        switch(task) {
            case 1: return (ColorEnum) YELLOW;
            case 2: return (ColorEnum) GREEN;
            case 3: return (ColorEnum) RED;
            case 4: return (ColorEnum) BLUE;
            case 5: return (ColorEnum) MAGENTA;
            case 6: return (ColorEnum) CYAN;
            case 7: default: return (ColorEnum) ORANGE;
        }
    }

    public String toString() {
        switch(this) {
            case YELLOW: return "YELLOW";
            case GREEN: return "GREEN";
            case RED: return "RED";
            case BLUE: return "BLUE";
            case MAGENTA: return "MAGENTA";
            case CYAN: return "CYAN";
            case ORANGE: return "ORANGE";
            default: return "";
        }
    }

    public Color color() {
        switch(this) {
            case YELLOW: return Color.YELLOW;
            case GREEN: return Color.GREEN;
            case RED: return Color.RED;
            case BLUE: return Color.BLUE;
            case MAGENTA: return Color.MAGENTA;
            case CYAN: return Color.CYAN;
            case ORANGE: default: return Color.ORANGE;
        }
    }

    public int value() { return task; }
}
