package strategy;

import java.util.Comparator;

import tasks.Taskset;
import tasks.Task;

public class NoneStrategy implements SchedulingStrategy {

    /*
     * Generate schedule from taskset ts based on the desired strategy
     * Return: int array containing task number i at slot position j. Empty array if taskset is invalid.
     */
    public int[] generate(Taskset ts) {
        return new int[0];
    } 

    /*
     * Return which Strategy you are using
     */
    public String toString() {
        return "None";
    }

    /*
     * Return a Comparator for this scheduling strategy
     */
    public Comparator<Task> prioComparator() {
        return new NoneComparator();
    }
}
