package strategy;

import java.util.Comparator;

import tasks.Taskset;
import tasks.Task;

public interface SchedulingStrategy {

    /*
     * Generate schedule from taskset ts based on the desired strategy
     * Return: int array containing task number i at slot position j. Empty array if taskset is invalid.
     */
    public int[] generate(Taskset ts); 

    /*
     * Return which Strategy you are using
     */
    public String toString();

    /*
     * Return a Comparator for this scheduling strategy
     */
    public Comparator<Task> prioComparator();

    /*
     * Return True if this is the same SchedulingStrategy as strat; else false
     */
    public default boolean equals(SchedulingStrategy strat) {
        return toString().equals(strat.toString());
    }
}
