package tasks;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileReader;
import java.util.Map;

public class TasksetBufferedReader extends BufferedReader {
    public TasksetBufferedReader(String name) throws FileNotFoundException {
        super(new FileReader(name));
    }

    public void load(Taskset taskset) throws NumberFormatException, IOException {
        try {
            while (ready()) {
                String[] line = readLine().trim().split(",");

                try {
                    taskset.addTask(parse(line[0]), parse(line[1]), parse(line[2]));
                } catch (NumberFormatException e) {
                    throw e;
                } 
            }
        } catch (IOException e) {
            throw e;
        }
    }

    private int parse(String s) throws NumberFormatException {
        try {
            return Integer.parseInt(s);
        } catch (NumberFormatException e) {
            throw e;
        }
    }
}
